
#include <stdio.h>
#include <mpi.h>
#include <math.h>

#define DIMENSIONE 300

int main (int argc, char **argv) {

  int myrank,i,count,size;
  MPI_Status status;
  double a[DIMENSIONE],b[DIMENSIONE];

  int blocco;

  MPI_Init(&argc, &argv);  /* Initialize MPI */
  MPI_Comm_rank(MPI_COMM_WORLD, &myrank); /* Get rank */
  MPI_Comm_size(MPI_COMM_WORLD,&size);

  blocco=DIMENSIONE/(size-1);

  if( myrank == 0 ) {        /* Send a message */
    for (i=0;i<DIMENSIONE;++i)
         a[i]=sqrt((double) i);
	for (i=1;i<size;i++)
		MPI_Send(a+((i-1)*blocco), blocco, MPI_DOUBLE, i, 17, MPI_COMM_WORLD );
  }
  else {   /* Receive a message */
    MPI_Recv( b, blocco, MPI_DOUBLE, MPI_ANY_SOURCE, MPI_ANY_TAG, MPI_COMM_WORLD,&status);
    MPI_Get_count(&status,MPI_DOUBLE,&count);
    printf("P:%d il messaggio e' arrivato dal processo %d\n",myrank,status.MPI_SOURCE);
    printf("P:%d il tag del messaggio e' %d\n",myrank,status.MPI_TAG);
    printf("P:%d la dimensione effettiva del messaggio e' %d\n",myrank,count);
  }
 MPI_Finalize();          /* Terminate MPI */
 return(0);
}
